%define enable_multilib 0

%global DATE 202405031
%define gcc_version		14.2.0
%define __gnuversion		14.2.0
%define __gnufullversion	14.2.0
%define __unamer		%(uname -r)
%define __arch			%(uname -p)
%ifarch x86_64
%define __arch64		x86_64
%else
%define __arch64		arm64
%endif

%define gcc_target_x86_64 x86_64-apple-darwin%(uname -r | cut -f1 -d.)
%define gcc_target_arm64 arm64-apple-darwin%(uname -r | cut -f1 -d.)

%define _osxver %(sw_vers -productVersion | cut -f1,2 -d.)

Summary: The GNU Compiler Collection: gcc, g++, d, and g95
Name: gcc
%define version %{__gnuversion}
Version: %{version}
Release: 1%{?_dist_release}
Source0: gcc-%{version}.tar.xz
Source1: osxws-setup-gcc.sh
# from https://github.com/fxcoudert/gcc/archive/refs/tags/gcc-11.2.0-arm-20211124.tar.gz
#Source2: localhost:/gcc-gcc-11.2.0-arm-20211124.tar.gz
#Source2: localhost:/gcc-11.2.0-arm-20211124.tar
#Patch2: localhost:/gcc-11.2.0-arm-20211124.patch
# from https://gcc.gnu.org/git/?p=gcc.git;a=patch;h=fabe8cc41e9b01913e2016861237d1d99d7567bf
#Patch102: localhost:/gcc-11-darwin.patch
# from https://raw.githubusercontent.com/Homebrew/formula-patches/82b5c1cd38826ab67ac7fc498a8fe74376a40f4a/gcc/gcc-14.1.0.diff
Patch1: gcc-%{version}.diff
Patch100: gcc-14-osxws.patch
Patch101: gcc-14-xcode16.patch

Group: Development/Languages
License: Apple Public Source License, GPL
BuildRoot: %{_tmppath}/%{name}-root
Requires(post): alternatives
Requires(postun): alternatives
Requires: alternatives gmp mpfr libmpc isl
BuildRequires: gmp-devel mpfr-devel libmpc-devel isl-devel
Provides: gcc = %{version}

Vendor:       OSX WorkShop
Distribution: OSX WorkShop

BuildArch: fat
ExclusiveArch: arm64 fat

%description
The GNU Compiler Collection: gcc, g++, and gfortran.

%prep
%setup -q -n gcc-%{version}

%patch1 -p1 -b .m1mac
%patch100 -p1 -b .macos14
%patch101 -p1 -b .xcode16

%build
export CPPFLAGS='-I%{_prefix}/include'
%if %{enable_multilib}
MULTILIB="--enable-multilib"
%else
MULTILIB="--disable-multilib"
%endif

mkdir ARM64
pushd ARM64
CC=clang CXX=clang++ \
../configure \
	--prefix=%{_prefix} --includedir=%{_prefix}/include --sysconfdir=%{_sysconfdir} \
	--mandir=%{_mandir} --datadir=%{_datadir} --infodir=%{_infodir} \
	--enable-languages=c,c++,objc,obj-c++,fortran \
%ifos darwin
	--with-sysroot=/Library/Developer/CommandLineTools/SDKs/MacOSX.sdk \
	--with-build-sysroot=/Library/Developer/CommandLineTools/SDKs/MacOSX.sdk \
%endif
	--with-gmp-lib=%{_prefix}/lib --with-gmp-include=%{_prefix}/include \
	--with-mpfr-lib=%{_prefix}/lib --with-mpfr-include=%{_prefix}/include \
	--with-mpc-lib=%{_prefix}/lib --with-mpc-include=%{_prefix}/include \
	--with-isl=%{_prefix} \
	--with-gxx-include-dir=%{_prefix}/include/c++/%{gcc_version} \
	--enable-shared --enable-threads=posix --enable-checking=release \
	--enable-bootstrap --with-system-zlib \
	--disable-nls \
	--build=%{gcc_target_arm64} \
	--host=%{gcc_target_arm64} \
	--target=%{gcc_target_arm64} \
	${MULTILIB} \
 	--enable-stage1-checking \
#%%ifos darwin
#	--with-build-sysroot=`xcrun --show-sdk-path` \
#%%endif
#	--with-sysroot=/Library/Developer/CommandLineTools/SDKs/MacOSX.sdk \
#	--disable-checking --enable-werror \
#	--enable-threads --disable-nls --disable-build-with-cxx \
#	--enable-gather-detailed-mem-stats --enable-decimal-float
#	AR="ar" AS="as" DLLTOOL="dlltool" LIPO="lipo" NM="nm" \
#	OBJCOPY='objcopy' OBJDUMP='objdump' WINDMC='windmc' WINDRES='windres'
#	--enable-fully-dynamic-string
#	--oldincludedir=/Library/Developer/CommandLineTools/SDKs/MacOSX10.14.sdk/usr/include \
#	--with-gcc-major-version-only \
# XXXX 20231012
#  Work around a bug in Xcode 15's new linker (FB13038083)
# --with-ld=/Library/Developer/CommandLineTools/usr/bin/ld-classic
	#--with-ld=/Library/Developer/CommandLineTools/usr/bin/ld-classic \

echo "_smp_mflags=%{_smp_mflags}"
make %{?_smp_mflags}
#make %{?_smp_mflags} bootstrap
popd

### for x86_64
mkdir X86_64
pushd X86_64
CC=clang CXX=clang++ \
arch -x86_64 ../configure \
	--prefix=%{_prefix} --includedir=%{_prefix}/include --sysconfdir=%{_sysconfdir} \
	--mandir=%{_mandir} --datadir=%{_datadir} --infodir=%{_infodir} \
%ifos darwin
	--with-sysroot=/Library/Developer/CommandLineTools/SDKs/MacOSX.sdk \
	--with-build-sysroot=/Library/Developer/CommandLineTools/SDKs/MacOSX.sdk \
%endif
	--enable-languages=c,c++,objc,obj-c++,fortran \
	--with-gmp-lib=%{_prefix}/lib --with-gmp-include=%{_prefix}/include \
	--with-mpfr-lib=%{_prefix}/lib --with-mpfr-include=%{_prefix}/include \
	--with-mpc-lib=%{_prefix}/lib --with-mpc-include=%{_prefix}/include \
	--with-isl=%{_prefix} \
	--with-gxx-include-dir=%{_prefix}/include/c++/%{gcc_version} \
	--enable-shared --enable-threads=posix --enable-checking=release \
	--enable-bootstrap --with-system-zlib \
	--disable-nls \
	--build=%{gcc_target_x86_64} \
	--host=%{gcc_target_x86_64} \
	--target=%{gcc_target_x86_64} \
	${MULTILIB} \
 	--enable-stage1-checking
	#--with-ld=/Library/Developer/CommandLineTools/usr/bin/ld-classic \

echo "_smp_mflags=%{_smp_mflags}"
arch -x86_64 make %{?_smp_mflags}
popd


%install
rm -rf %{buildroot}
mkdir -p %{buildroot}

PWD=`pwd`
pushd ARM64
rm -rf ${PWD}-root
mkdir -p ${PWD}-root
export CPPFLAGS='-I%{_prefix}/include'
make install DESTDIR=${PWD}-root
popd
pushd X86_64
rm -rf ${PWD}-root
mkdir -p ${PWD}-root
export CPPFLAGS='-I%{_prefix}/include'
arch -x86_64 make install DESTDIR=${PWD}-root
popd

# copy x86_64 arch dirs to arm64 tree
#for i in `find X86_64-root -type d | sed -n -e '/.*x86_64-apple-darwin21$/s|X86_64-root/||p'`
#do
#  cp -a "X86_64-root/${i}" "ARM64-root/${i}"
#done

find ARM64-root -type d | sed 's|ARM64-root/||g' > arm64Dirs
find ARM64-root -type f | sed '/.*arm64-apple-darwin21.*/d;s|ARM64-root/||g' > arm64Files
find X86_64-root -type d | sed 's|X86_64-root/||g' > x86_64Dirs
find X86_64-root -type f | sed '/.*x86_64-apple-darwin21.*/d;s|X86_64-root/||g' > x86_64Files

for i in `diff -u arm64Dirs x86_64Dirs | sed -n -e '/^\+opt/s|+||p'`
do
  cp -a "X86_64-root/${i}" "ARM64-root/${i}"
done

# copy x86_64 arch files to arm64 tree
for i in `diff -u arm64Files x86_64Files | sed -n -e '/^\+opt/s|+||p'`
do
  cp -p "X86_64-root/${i}" "ARM64-root/${i}"
done
cp -p X86_64-root/%{_bindir}/%{gcc_target_x86_64}* ARM64-root/%{_bindir}/

## Make Universal Binaries
#filelist=$(cat arm64Files x86_64Files | sort | uniq -d ) 
cat arm64Files x86_64Files | sort | uniq -d > filelist.tmp

rm -rf binTmpDir
mkdir binTmpDir
lipolist=`cat filelist.tmp | sed -e 's|^|ARM64-root/|g' | \
          xargs file | sed -e 's,^ARM64-root/,,g' | \
          grep -E \(Mach-O\)\|\(ar\ archive\) |sed -e 's,:.*,,g' -e '/for\ architecture/d'`
for i in $lipolist
do
        /usr/bin/lipo -create ARM64-root/$i X86_64-root/$i -output binTmpDir/${i##*/} && \
        (cp -f binTmpDir/${i##*/} ARM64-root/$i) || :
done

# check header files
for TARGET in `cat filelist.tmp | grep -e '.h$'`
do
        TEMP=`diff -u ARM64-root/$TARGET X86_64-root/$TARGET > /dev/null || echo different`
        if [ -n "$TEMP" ]; then
                mv X86_64-root/$TARGET ARM64-root/${TARGET%.*}-x86_64.h
                mv ARM64-root/$TARGET ARM64-root/${TARGET%.*}-arm64.h
                FILE=${TARGET##*/}
                FILE=${FILE%.*}
cat <<EOF > ARM64-root/$TARGET
#if defined (__arm64__)
#include "${FILE}-arm64.h"
#elif defined( __x86_64__ )
#include "${FILE}-x86_64.h"
#endif
EOF
        fi
done

# install
mkdir -p %{buildroot}
tar cf - -C ARM64-root . | tar xpf - -C %{buildroot}


[ -f altflist.b ] && rm -f altflist.b ||:
[ -f altflist.l ] && rm -f altflist.l ||:

# Remove unwanted files
rm -f %{buildroot}%{_libdir}/lib*.la
rm -f %{buildroot}%{_infodir}/dir
rm -f %{buildroot}%{_bindir}/*darwin*darwin*

# rename x86_64 bin
pushd %{buildroot}%{_bindir}
  rm -f %{gcc_target_arm64}-gcc-%{gcc_version} %{gcc_target_x86_64}-gcc-%{gcc_version}
  for i in `\ls |grep -v apple-darwin`
    do
    if [ -f "$i" ] ; then
      mv -f $i $i-%{gcc_version}
      echo "--slave   %{_bindir}/${i} ${i} %{_bindir}/${i}-%{gcc_version} \\" >> \
	%{_builddir}/%{name}-%{version}/altflist.b
	#"
    fi
  done
popd


# for alternatives
pushd %{buildroot}%{_bindir}
  for i in %{gcc_target_arm64}-* %{gcc_target_x86_64}-*
  do
    if [ -f "$i" ] ; then
      mv -f $i $i-%{gcc_version}
      echo "--slave   %{_bindir}/${i} ${i} %{_bindir}/${i}-%{gcc_version} \\" >> \
	%{_builddir}/%{name}-%{version}/altflist.b
      #" ln -sf $i-%{gcc_version} $i
    fi
  done
popd
pushd %{buildroot}%{_libdir}
  rm -f libgcc_s_x86_64.*.dylib libgcc_s_arm64.*.dylib
  for i in lib*.dylib lib*.a lib*.o lib*.so \
	lib*.spec lib*.py x86_64/libiberty.a arm64/libiberty.a; do
    if [ -f "$i" ] ; then
      mv -f $i $i-%{gcc_version}
      chmod 755 $i-%{gcc_version}
      echo "--slave   %{_libdir}/${i} ${i} %{_libdir}/${i}-%{gcc_version} \\" >> \
	%{_builddir}/%{name}-%{version}/altflist.l
      #" ln -sf $i-%{gcc_version} $i
    elif [ -L "$i" ] ; then
      mv -f $i $i-%{gcc_version}
      #chmod 755 $i-%{gcc_version}
      echo "--slave   %{_libdir}/${i} ${i} %{_libdir}/${i}-%{gcc_version} \\" >> \
	%{_builddir}/%{name}-%{version}/altflist.l
      #" remove link files
      rm -f $i ||:
    fi
  done
popd

#rm -f %{buildroot}%{_libdir}/{libasan,libatomic}.dylib
#rm -f %{buildroot}%{_libdir}/{libstdc++,libgfortran,libquadmath}.dylib
#rm -f %{buildroot}%{_libdir}/{libgomp,libobjc-gnu,libssp,libitm}.dylib

# for osxws-setup-gcc
mkdir -p %{buildroot}/%{_var}/lib/gcc/
cat << 'EOF' > %{buildroot}/%{_var}/lib/gcc/alternative-gcc
#!/bin/bash

%{_sbindir}/alternatives \
  --install %{_bindir}/gcc gcc %{_bindir}/gcc-%{gcc_version} 30 \
  --slave   %{_bindir}/cc  cc  %{_bindir}/gcc-%{gcc_version} \
EOF
sed -e '/.*bin\/gcc gcc .*/d' altflist.b >> %{buildroot}/%{_var}/lib/gcc/alternative-gcc
sed -e '$s,\\$,,' altflist.l >> %{buildroot}/%{_var}/lib/gcc/alternative-gcc
chmod 755 %{buildroot}/%{_var}/lib/gcc/alternative-gcc

# for osxws-setup-gcc
mkdir -p %{buildroot}%{_libdir}/gcc/Packages
#install -m 755 %{SOURCE1} %{buildroot}%{_bindir}/osxws-setup-gcc
cat << 'EOF' > %{buildroot}/%{_bindir}/osxws-setup-gcc
#!/bin/bash

PKGDIR="%{_libdir}/gcc/Packages/"
COMMAND=${0##*/}

if [ 0 -eq $# ]; then
	echo "Usage: $COMMAND {auto|gcc|llvm}"
	exit 0
fi

if [ "$USER" != "root" ]; then
	echo "$COMMAND: please execute by root user"
	exit 0
fi

for PKG in ${PKGDIR}/*
do
	${PKG} $@
done
EOF
chmod 755 %{buildroot}/%{_bindir}/osxws-setup-gcc

cat << 'EOF' > %{buildroot}/%{_libdir}/gcc/Packages/%{name}
#!/bin/bash

if [ "$USER" != "root" ]; then
	echo "  please execute by root user"
	exit 0
fi

case $1 in
	auto)
		echo "  setup: gcc to auto"
		%{_sbindir}/alternatives --auto gcc;;
	gcc)
		echo "  setup: gcc to gcc"
		%{_sbindir}/alternatives --set gcc %{_bindir}/gcc-%{gcc_version};;
	llvm|clang)
		echo "  setup: gcc to llvm clang"
		%{_sbindir}/alternatives --set gcc /usr/bin/clang;;
	*) echo "$0: unknown argument: $1";;
esac
EOF
chmod 755 %{buildroot}/%{_libdir}/gcc/Packages/%{name}

# Make list of files in the package

find %{buildroot} -type f > list.f
find %{buildroot} -type l > list.l
sed -e "s;%{buildroot};;" list.f > list.new
mv list.new list.f
sed -e "s,%{buildroot},," list.l > list.new
mv list.new list.l
cat list.l >> list.f
cat list.f | sed -e 's;\(%{_mandir}/.*/.*\..*\);\1*;' \
	         -e 's;\(%{_infodir}/.*\..*\);\1*;' \
	   | sed -n -e '/.*\.la$/!p' > list.new
mv list.new list.f

%clean
rm -rf %{buildroot}

%post
# this package (default)
%{_var}/lib/gcc/alternative-gcc

# Apple 8.0.0 llvm default
%{_sbindir}/alternatives \
  --install %{_bindir}/gcc gcc /usr/bin/clang 20 \
  --slave   %{_bindir}/cc  cc  /usr/bin/clang \
  --slave   %{_bindir}/g++ g++ /usr/bin/clang++ \
  --slave   %{_bindir}/c++ c++ /usr/bin/clang++ \
  --slave %{_bindir}/cpp cpp    /usr/bin/cpp \
  --slave %{_bindir}/gcov gcov    /usr/bin/gcov \
  --slave   %{_bindir}/gfortran gfortran %{_bindir}/gfortran-%{gcc_version} \
#  --slave   %{_libdir}/libgcc_s.1.1.dylib libgcc_s.1.1.dylib %{_libdir}/libgcc_s.1.1.dylib-%{gcc_version} \
#  --slave   %{_libdir}/libgfortran.5.dylib libgfortran.5.dylib %{_libdir}/libgfortran.5.dylib-%{gcc_version} \
#  --slave   %{_libdir}/libgfortran.dylib libgfortran.dylib %{_libdir}/libgfortran.5.dylib-%{gcc_version} \
#  --slave   %{_libdir}/libgfortran.a libgfortran.a %{_libdir}/libgfortran.a-%{gcc_version} \
#  --slave   %{_libdir}/libgfortran.spec libgfortran.spec %{_libdir}/libgfortran.spec-%{gcc_version} 

#  --slave %{_libdir}/libgcc_s.1.dylib libgcc_s.1.dylib /usr/lib/libgcc_s.1.dylib \
#  --slave %{_libdir}/libgcc_s.10.4.tbd libgcc_s.10.4.tbd /usr/lib/libgcc_s.10.4.tbd \
#  --slave %{_libdir}/libgcc_s.10.5.tbd libgcc_s.10.5.tbd /usr/lib/libgcc_s.10.5.tbd \
#  --slave %{_libdir}/libstdc++.6.dylib libstdc++.6.dylib /usr/lib/libstdc++.6.dylib

# clean up olds
%{_sbindir}/alternatives --display gcc | grep -q bin/llvm-gcc && \
        %{_sbindir}/alternatives --remove gcc /usr/bin/llvm-gcc || :
%{_sbindir}/alternatives --display gcc | grep -q bin/llvm-gcc-4.2 && \
        %{_sbindir}/alternatives --remove gcc /usr/bin/llvm-gcc-4.2 || :
%{_sbindir}/alternatives --display gcc | grep -q bin/gcc-4.2 && \
	%{_sbindir}/alternatives --remove gcc /usr/bin/gcc-4.2 || :
%{_sbindir}/alternatives --display gcc | grep -q bin/gcc-x86_64-4.8.4 && \
	%{_sbindir}/alternatives --remove gcc /usr/osxws/bin/gcc-x86_64-4.8.4 || : 
%{_sbindir}/alternatives --display gcc | grep -q bin/gcc-x86_64-5.3.0 && \
	%{_sbindir}/alternatives --remove gcc /opt/osxws/bin/gcc-x86_64-5.3.0 || :
%{_sbindir}/alternatives --display gcc | grep -q bin/gcc-x86_64-7.3.0 && \
	%{_sbindir}/alternatives --remove gcc /opt/osxws/bin/gcc-x86_64-7.3.0 || :

# fix broken symlink if it's there
if [ ! -f %{_bindir}/gcc ] ; then
  echo "%{_sbindir}/alternatives --auto gcc"
  %{_sbindir}/alternatives --auto gcc
fi

%postun
if [ $1 = 0 ]; then
  %{_sbindir}/alternatives --remove gcc %{_bindir}/gcc-%{gcc_version}
  %{_sbindir}/alternatives --auto gcc
fi

%triggerpostun -- gcc < %{version}-%{release}
%{_sbindir}/alternatives --auto gcc

%files -f list.f
%defattr(-,root,wheel)
%dir %{_prefix}/include/c++/%{__gnuversion}
%dir %{_prefix}/include/c++/%{__gnuversion}/backward
%dir %{_prefix}/include/c++/%{__gnuversion}/bits
%dir %{_prefix}/include/c++/%{__gnuversion}/debug
%dir %{_prefix}/include/c++/%{__gnuversion}/ext
%dir %{_prefix}/include/c++/%{__gnuversion}/ext/pb_ds
%dir %{_prefix}/include/c++/%{__gnuversion}/ext/pb_ds/detail
%dir %{_prefix}/include/c++/%{__gnuversion}/ext/pb_ds/detail/bin_search_tree_
%dir %{_prefix}/include/c++/%{__gnuversion}/ext/pb_ds/detail/binary_heap_
%dir %{_prefix}/include/c++/%{__gnuversion}/ext/pb_ds/detail/binomial_heap_
%dir %{_prefix}/include/c++/%{__gnuversion}/ext/pb_ds/detail/binomial_heap_base_
%dir %{_prefix}/include/c++/%{__gnuversion}/ext/pb_ds/detail/cc_hash_table_map_
%dir %{_prefix}/include/c++/%{__gnuversion}/ext/pb_ds/detail/eq_fn
%dir %{_prefix}/include/c++/%{__gnuversion}/ext/pb_ds/detail/gp_hash_table_map_
%dir %{_prefix}/include/c++/%{__gnuversion}/ext/pb_ds/detail/hash_fn
%dir %{_prefix}/include/c++/%{__gnuversion}/ext/pb_ds/detail/left_child_next_sibling_heap_
%dir %{_prefix}/include/c++/%{__gnuversion}/ext/pb_ds/detail/list_update_map_
%dir %{_prefix}/include/c++/%{__gnuversion}/ext/pb_ds/detail/list_update_policy
%dir %{_prefix}/include/c++/%{__gnuversion}/ext/pb_ds/detail/ov_tree_map_
%dir %{_prefix}/include/c++/%{__gnuversion}/ext/pb_ds/detail/pairing_heap_
%dir %{_prefix}/include/c++/%{__gnuversion}/ext/pb_ds/detail/pat_trie_
%dir %{_prefix}/include/c++/%{__gnuversion}/ext/pb_ds/detail/rb_tree_map_
%dir %{_prefix}/include/c++/%{__gnuversion}/ext/pb_ds/detail/rc_binomial_heap_
%dir %{_prefix}/include/c++/%{__gnuversion}/ext/pb_ds/detail/resize_policy
%dir %{_prefix}/include/c++/%{__gnuversion}/ext/pb_ds/detail/splay_tree_
%dir %{_prefix}/include/c++/%{__gnuversion}/ext/pb_ds/detail/thin_heap_
%dir %{_prefix}/include/c++/%{__gnuversion}/ext/pb_ds/detail/tree_policy
%dir %{_prefix}/include/c++/%{__gnuversion}/ext/pb_ds/detail/trie_policy
%dir %{_prefix}/include/c++/%{__gnuversion}/ext/pb_ds/detail/unordered_iterator
%if %{enable_multilib}
%dir %{_prefix}/include/c++/%{__gnuversion}/%{gcc_target_platform32}/%{__arch64}
%dir %{_prefix}/include/c++/%{__gnuversion}/%{gcc_target_platform32}/%{__arch64}/bits
%endif
%dir %{_prefix}/include/c++/%{__gnuversion}/%{gcc_target_arm64}
%dir %{_prefix}/include/c++/%{__gnuversion}/%{gcc_target_x86_64}
%dir %{_prefix}/include/c++/%{__gnuversion}/%{gcc_target_arm64}/bits
%dir %{_prefix}/include/c++/%{__gnuversion}/%{gcc_target_x86_64}/bits
%if %{enable_multilib}
%dir %{_prefix}/include/c++/%{__gnuversion}/%{gcc_target_platform64}/i386
%dir %{_prefix}/include/c++/%{__gnuversion}/%{gcc_target_platform64}/i386/bits
%endif
%dir %{_prefix}/include/c++/%{__gnuversion}/parallel
%dir %{_prefix}/include/c++/%{__gnuversion}/tr1

%if %{enable_multilib}
%dir %{_prefix}/lib/gcc/%{gcc_target_platform32}/%{__gnufullversion}/%{__arch64}
%endif
%dir %{_prefix}/lib/gcc/%{gcc_target_arm64}/%{__gnufullversion}
%dir %{_prefix}/lib/gcc/%{gcc_target_x86_64}/%{__gnufullversion}
%dir %{_prefix}/lib/gcc/%{gcc_target_arm64}/%{__gnufullversion}/finclude
%dir %{_prefix}/lib/gcc/%{gcc_target_x86_64}/%{__gnufullversion}/finclude
%dir %{_prefix}/lib/gcc/%{gcc_target_arm64}/%{__gnufullversion}/include
%dir %{_prefix}/lib/gcc/%{gcc_target_x86_64}/%{__gnufullversion}/include
%dir %{_prefix}/lib/gcc/%{gcc_target_arm64}/%{__gnufullversion}/include/ssp
%dir %{_prefix}/lib/gcc/%{gcc_target_x86_64}/%{__gnufullversion}/include/ssp
%dir %{_prefix}/lib/gcc/%{gcc_target_arm64}/%{__gnufullversion}/include-fixed
%dir %{_prefix}/lib/gcc/%{gcc_target_x86_64}/%{__gnufullversion}/include-fixed
%dir %{_prefix}/lib/gcc/%{gcc_target_arm64}/%{__gnufullversion}/install-tools
%dir %{_prefix}/lib/gcc/%{gcc_target_x86_64}/%{__gnufullversion}/install-tools
%dir %{_prefix}/lib/gcc/%{gcc_target_arm64}/%{__gnufullversion}/install-tools/include
%dir %{_prefix}/lib/gcc/%{gcc_target_x86_64}/%{__gnufullversion}/install-tools/include
%if %{enable_multilib}
%dir %{_prefix}/lib/gcc/%{gcc_target_platform64}/%{__gnufullversion}/i386
%endif

%dir %{_prefix}/libexec/gcc/%{gcc_target_arm64}/%{__gnufullversion}
%dir %{_prefix}/libexec/gcc/%{gcc_target_x86_64}/%{__gnufullversion}
%dir %{_prefix}/libexec/gcc/%{gcc_target_arm64}/%{__gnufullversion}/install-tools
%dir %{_prefix}/libexec/gcc/%{gcc_target_x86_64}/%{__gnufullversion}/install-tools

%changelog
* Mon Dec 9 2024 Keisuke Fujii <keisuke.fujii@kek.jp> 14.2.0-1
- new upstream release
- modified xcode16 patch
- built with Xcode16 
- for OSXWS-14 fat

* Fri Dec 6 2024 Keisuke Fujii <keisuke.fujii@kek.jp> 14.1.0-1
- added xcode16 patch
- rebuilt with Xcode16 
- for OSXWS-14 fat

* Fri May 31 2024 KOBAYASHI Taizo <tkoba965@me.com> 14.1.0-1
- new upstream release
- for OSXWS-14 fat

* Thu Oct 12 2023 KOBAYASHI Taizo <tkoba965@me.com> 13.2.0-1
- new upstream release
- for OSXWS-13 fat

* Sat Mar 12 2022 KOBAYASHI Taizo <tkoba965@me.com> 11.2.0-6
- for OSXWS-12 fat
- use commandline sdk as sysroot

* Wed Mar 9 2022 FUJII Keisuke <keisuke.fujii@kek.jp> 11.2.0-5
- 5th build on MacOS12 with OSXWS 12beta for Intel Macs

* Sat Feb 26 2022 FUJII Keisuke <keisuke.fujii@kek.jp> 11.2.0-4
- 4th build on MacOS12 with OSXWS 12beta for M1 Macs

* Mon Feb 14 2022 FUJII Keisuke <keisuke.fujii@kek.jp> 11.2.0-3
- enable rpath and enable -isysroot
- configure --with-build-sysroot 
- set default_sdkroot and rpath
- 3rd build on MacOS12.1

* Sat Feb 12 2022 FUJII Keisuke <keisuke.fujii@kek.jp> 11.2.0-2
- enable rpath and enable -isysroot
- configure --with-build-sysroot 
- 2nd build on MacOS12.1

* Fri Feb 11 2022 FUJII Keisuke <keisuke.fujii@kek.jp> 11.2.0-1
- disable rpath and enable -isysroot
- configure --with-build-sysroot 
- 1st build on MacOS12.1

* Thu Jan 27 2022 FUJII Keisuke <keisuke.fujii@kek.jp> 11.2.0-0
- new upstream release
- added Source2, patch102, patch103 for arm64 support
- 0th build on MacOS12.1

* Thu Aug 05 2021 KOBAYASHI Taizo <tkoba965@me.com> 11.2.0-0
- new upstream release
- for OSXWS-11

* Sat Dec 21 2019 KOBAYASHI Taizo <tkoba965@me.com> 9.2.0-1
- new upstream release
- for OSXWS-10.14

* Mon Dec 24 2018 Keisuke Fujii <keisuke.fujii@kek.jp> 7.3.0-1
- for OSXWS-10.14 built with MacOSX WX 10.13

* Sun Apr 01 2018 Keisuke Fujii <keisuke.fujii@kek.jp> 7.3.0-1
- new upstream release
- for OSXWS-10.13

* Sat Dec 03 2016 KOBAYASHI Taizo <tkoba965@me.com> 6.2.0-1
- new upstream release
- for OSXWS-10.12
- alternatives setting: clean up 5.3.0

* Thu Dec 10 2015 KOBAYASHI Taizo <tkoba965@me.com> 5.3.0-1
- new upstream release
- for OSXWS-10.11
- alternatives setting: clean up 4.8.4

* Mon Feb 09 2015 KOBAYASHI Taizo <tkoba965@me.com> 4.8.4-2
- alternatives setting: clean up 4.8.2

* Wed Dec 24 2014 FUJII Keisuke <keisuke.fujii@kek.jp> 4.8.4-1
- 1st release on MacOSX 10.10

* Tue Aug 12 2014 KOBAYASHI Taizo <tkoba965@me.com> 4.8.2-2
- alternatives setting: llvm-gcc -> clang

* Mon Jun 16 2014 KOBAYASHI Taizo <tkoba965@me.com> 4.8.2-1
- add Obsoletes gcc47

* Fri May 09 2014 KOBAYASHI Taizo <tkoba965@me.com> 4.8.2-0
- new upstream release
- for OSX 10.9

* Thu May 02 2013 KOBAYASHI Taizo <tkoba965@me.com> 4.7.1-1
- new upstream release

* Thu May 02 2013 KOBAYASHI Taizo <tkoba965@me.com> 4.7.2-2
- clean up old entries for alternatives

* Mon Apr 08 2013 KOBAYASHI Taizo <tkoba965@me.com> 4.7.2-1
- new upstream release
- OSXWS 10.8

* Fri Feb 03 2012 KOBAYASHI Taizo <tkoba965@me.com> 4.6.2-1
- new upstream release
- OSXWS 10.7

* Sat Feb 12 2011 Akihiro Uchida <uchida@ike-dyn.ritsumei.ac.jp> 4.5.1-6
- add lib{gomp,objc-gnu,ssp}*.dylib to update-altenatives
- add libmpc-devel to BuildRequires

* Tue Feb 01 2011 KOBAYASHI Taizo <tkoba965@me.com> 4.5.1-5
- add symlink of libstdc++.dylib and libgfortran.dylib

* Fri Nov 12 2010 KOBAYASHI Taizo <tkoba965@me.com> 4.5.1-4
- drop x86_64 bin of i686-apple-darwin10 bins
- add *-32 links for making i386 bin

* Fri Sep 10 2010 KOBAYASHI Taizo <tkoba965@me.com> 4.5.1-2
- use configure options from MacPorts gcc45

* Tue Sep 07 2010 KOBAYASHI Taizo <tkoba965@me.com> 4.5.1-1
- new upstream release

* Tue Sep 07 2010 KOBAYASHI Taizo <tkoba965@me.com> 4.4.4-1
- new upstream release

* Mon Aug 30 2010 KOBAYASHI Taizo <tkoba965@me.com> 4.4.3-7
- rebuild with gmp-5.0.1 and mpfr-3.0.0-p3

* Fri Mar 19 2010 KOBAYASHI Taizo <tkoba965@me.com> 4.4.3-6
- added more pr41260 patch against gcc/config/darwin9.h
  Thanks' Fujii-san!

* Tue Mar 16 2010 KOBAYASHI Taizo <tkoba965@me.com> 4.4.3-5
- added pr41260 patch for libgcc_s link problem
  Thanks' Fujii-san!

* Mon Mar 15 2010 KOBAYASHI Taizo <tkoba965@me.com> 4.4.3-4
- include some pathces from Vine gcc-4.4.3-3

* Fri Mar 05 2010 KOBAYASHI Taizo <tkoba965@me.com> 4.4.3-3
- fix aluternatives scripts:
  gcc_target_platform to gcc_target_platform32 and gcc_target_platform64

* Wed Mar 03 2010 KOBAYASHI Taizo <tkoba965@me.com> 4.4.3-2
- drop --program-transform-name to configure

* Wed Feb 10 2010 KOBAYASHI Taizo <tkoba965@me.com> 4.4.3-1
- new upstream release
- BuildArch fat
- for OSXWS 10.6

* Sat Jun 28 2008 KOBAYASHI Taizo <tkoba965@me.com> 4.3.0-10.5hepx1d
- drop libstdc++.dylib because Apple's GCC does not include it.
- libgcc_s.*.dylib and libstdc++.6.dylib are managed under the alternatives.

* Wed May 14 2008 KOBAYASHI Taizo <tkoba965@me.com> 4.3.0-10.5hepx1c
- using alternatives

* Thu Mar 27 2008 Keisuke Fujii <keisuke.fujii@kek.jp> 4.3.0-10.5hepx1b
- 1st build on MacOS X 10.5 for ppc Macs
- gcc.spec modified to accomodate ppc architecture.

* Sat Mar 22 2008 Keisuke Fujii <keisuke.fujii@kek.jp> 4.3.0-10.5hepx1a
- 1st build on MacOS X 10.5 for Intel Macs

* Tue Mar 18 2008 Keisuke Fujii <keisuke.fujii@kek.jp> 4.3.0-1a
- 1st build on MacOS X 10.5 for Intel Macs

* Wed Apr 18 2007 Keisuke Fujii <keisuke.fujii@kek.jp> 4.2.0-svn20061005b
- 2nd build on MacOS X 10.4 for Intel Macs with gettext-0.16.2.

* Thu Oct 05 2006 Keisuke Fujii <keisuke.fujii@kek.jp> 4.2.0-svn20061005a
- 1st build on MacOS X 10.4 for Intel Macs.

* Fri Nov 25 2005 Keisuke Fujii <keisuke.fujii@kek.jp> 4.1.0-svn20051124b
- 11th build on MacOS X 10.4.
- disabled gthread for libgfortran

* Thu Nov 24 2005 Keisuke Fujii <keisuke.fujii@kek.jp> 4.1.0-svn20051124a
- 10th build on MacOS X 10.4.

* Mon Nov  7 2005 Keisuke Fujii <keisuke.fujii@kek.jp> 4.1.0-cvs20051004b
- 9th build on MacOS X 10.4.
- added lang-specs patch.

* Tue Oct  4 2005 Keisuke Fujii <keisuke.fujii@kek.jp> 4.1.0-cvs20051004a
- 8th build on MacOS X 10.4.

* Tue Sep 27 2005 Keisuke Fujii <keisuke.fujii@kek.jp> 4.1.0-cvs20050927a
- 7th build on MacOS X 10.4.
- applied csqrt patch.

* Thu Sep 22 2005 Keisuke Fujii <keisuke.fujii@kek.jp> 4.1.0-cvs20050921c
- 6th build on MacOS X 10.4.
- applied noauto and csqrt patches.

* Sun Sep 18 2005 Keisuke Fujii <keisuke.fujii@kek.jp> 4.1.0-cvs20050918a
- 5th build on MacOS X 10.4.

* Mon Aug 29 2005 Keisuke Fujii <keisuke.fujii@kek.jp> 4.1.0-cvs20050829a
- 4th build on MacOS X 10.4.

* Tue Jul 19 2005 Keisuke Fujii <keisuke.fujii@kek.jp> 4.1.0-cvs20050719a
- 3rd build on MacOS X 10.4.
- applied noauto patche.

* Wed Jun 29 2005 Keisuke Fujii <keisuke.fujii@kek.jp> 4.1.0-cvs20050629a
- 2nd build on MacOS X 10.4.
- applied hollerith and noauto patches.

* Wed Jun 22 2005 Keisuke Fujii <keisuke.fujii@kek.jp> 4.1.0-cvs20050622a
- 2nd build on MacOS X 10.4.
- applied hollerith and noauto patches.

* Sat Jun  4 2005 Keisuke Fujii <keisuke.fujii@kek.jp> 4.1.0-cvs20050528a
- 1st build on MacOS X 10.4.
- applied hollerith patch.

